#include "tipos_.h"
#include "agenda_mab.h"
#include <stdlib.h>
#include <stdio.h>
#include "log_mab.h"

#define mab_TAM_AGENDA 100
int mab_pos_libre=0;
int mab_agenda_vacia=FALSE;

mab_REGAGENDA mab_AGENDA[mab_TAM_AGENDA];
LISTA_REG mab_TABLA_PRIO[21];

extern void mab_marca_activada();
extern int mab_marca_desactivada();

mab_REGAGENDA mab_obten_regla_mas_prio()
{
	int i;
	int pos_regla;

	i=20;
	while(!mab_TABLA_PRIO[i].ptro_ini && i>=0) i--;
	if (i>=0) {
		pos_regla=mab_TABLA_PRIO[i].ptro_ini;
		mab_log_regla_mas_prio(mab_AGENDA[pos_regla]);
		return mab_AGENDA[pos_regla];
	} else mab_agenda_vacia = TRUE;
}

void mab_insregla_agenda(r)
	 mab_REGAGENDA r;
{
	int pos_regla;
	int pos_ini;
	int pos_fin;

	mab_log_insregla(r);
	pos_regla=mab_pos_libre;
	if (mab_pos_libre>=mab_TAM_AGENDA) {
	printf("Error: La agenda se ha desbordado\n");
	    exit(1); }
	mab_pos_libre=mab_AGENDA[mab_pos_libre].ptro_sig;
	if (mab_estrategia==profundidad) {
		pos_ini=mab_TABLA_PRIO[r.prioridad+10].ptro_ini;
		mab_TABLA_PRIO[r.prioridad+10].ptro_ini=pos_regla;
		if (mab_TABLA_PRIO[r.prioridad+10].ptro_fin==0) mab_TABLA_PRIO[r.prioridad+10].ptro_fin=pos_regla;
			    else mab_AGENDA[pos_ini].ptro_ant=pos_regla;
		mab_AGENDA[pos_regla] = r;
		mab_AGENDA[pos_regla].ptro_sig=pos_ini;
		mab_AGENDA[pos_regla].ptro_ant=0;
	} else if (mab_estrategia==anchura) {
		pos_fin=mab_TABLA_PRIO[r.prioridad+10].ptro_fin;
		mab_TABLA_PRIO[r.prioridad+10].ptro_fin=pos_regla;
		if (mab_TABLA_PRIO[r.prioridad+10].ptro_ini==0) mab_TABLA_PRIO[r.prioridad+10].ptro_ini=pos_regla;
			    else mab_AGENDA[pos_fin].ptro_sig=pos_regla;
		mab_AGENDA[pos_regla] = r;
		mab_AGENDA[pos_regla].ptro_sig=0;
		mab_AGENDA[pos_regla].ptro_ant=pos_fin;
	}
	mab_marca_activada(r,pos_regla);
}

void mab_elimregla_agenda(r)
	 mab_REGAGENDA r;
{
	int pos_regla;
	int pos_ant,pos_sig;
	char priori;

	mab_log_elimregla(r);
	pos_regla = mab_marca_desactivada(r);
	pos_ant=mab_AGENDA[pos_regla].ptro_ant;
	pos_sig=mab_AGENDA[pos_regla].ptro_sig;
	priori=mab_AGENDA[pos_regla].prioridad+10;
	if (pos_ant!=0) { mab_AGENDA[pos_ant].ptro_sig=pos_sig; }
		 else { mab_TABLA_PRIO[priori].ptro_ini=pos_sig; }
	if (pos_sig!=0) { mab_AGENDA[pos_sig].ptro_ant=pos_ant; }
		 else { mab_TABLA_PRIO[priori].ptro_fin=pos_ant; }
	mab_AGENDA[pos_regla].ptro_sig=mab_pos_libre;
	mab_pos_libre=pos_regla;
}

void mab_Inicializa_agenda()
{
	int iter1;

mab_agenda_vacia = FALSE;
	mab_pos_libre=1;
	for(iter1=1; iter1<mab_TAM_AGENDA; iter1++)
		 mab_AGENDA[iter1].ptro_sig=iter1+1;
	for(iter1=0; iter1<21; iter1++) {
		 mab_TABLA_PRIO[iter1].ptro_ini=0;
		 mab_TABLA_PRIO[iter1].ptro_fin=0;
	}
}

