#include "tipos_.h"
#include "agenda_templ3slot.h"
#include <stdlib.h>
#include <stdio.h>

#define templ3s_TAM_AGENDA 100
int templ3s_pos_libre=0;
int templ3s_agenda_vacia=FALSE;

templ3s_REGAGENDA templ3s_AGENDA[templ3s_TAM_AGENDA];
LISTA_REG templ3s_TABLA_PRIO[21];

extern void templ3s_marca_activada();
extern int templ3s_marca_desactivada();

templ3s_REGAGENDA templ3s_obten_regla_mas_prio()
{
	int i;
	int pos_regla;

	i=20;
	while(!templ3s_TABLA_PRIO[i].ptro_ini && i>=0) i--;
	if (i>=0) {
		pos_regla=templ3s_TABLA_PRIO[i].ptro_ini;
		return templ3s_AGENDA[pos_regla];
	} else templ3s_agenda_vacia = TRUE;
}

void templ3s_insregla_agenda(r)
	 templ3s_REGAGENDA r;
{
	int pos_regla;
	int pos_ini;
	int pos_fin;

	pos_regla=templ3s_pos_libre;
	if (templ3s_pos_libre>=templ3s_TAM_AGENDA) {
	printf("Error: La agenda se ha desbordado\n");
	    exit(1); }
	templ3s_pos_libre=templ3s_AGENDA[templ3s_pos_libre].ptro_sig;
	if (templ3s_estrategia==profundidad) {
		pos_ini=templ3s_TABLA_PRIO[r.prioridad+10].ptro_ini;
		templ3s_TABLA_PRIO[r.prioridad+10].ptro_ini=pos_regla;
		if (templ3s_TABLA_PRIO[r.prioridad+10].ptro_fin==0) templ3s_TABLA_PRIO[r.prioridad+10].ptro_fin=pos_regla;
			    else templ3s_AGENDA[pos_ini].ptro_ant=pos_regla;
		templ3s_AGENDA[pos_regla] = r;
		templ3s_AGENDA[pos_regla].ptro_sig=pos_ini;
		templ3s_AGENDA[pos_regla].ptro_ant=0;
	} else if (templ3s_estrategia==anchura) {
		pos_fin=templ3s_TABLA_PRIO[r.prioridad+10].ptro_fin;
		templ3s_TABLA_PRIO[r.prioridad+10].ptro_fin=pos_regla;
		if (templ3s_TABLA_PRIO[r.prioridad+10].ptro_ini==0) templ3s_TABLA_PRIO[r.prioridad+10].ptro_ini=pos_regla;
			    else templ3s_AGENDA[pos_fin].ptro_sig=pos_regla;
		templ3s_AGENDA[pos_regla] = r;
		templ3s_AGENDA[pos_regla].ptro_sig=0;
		templ3s_AGENDA[pos_regla].ptro_ant=pos_fin;
	}
	templ3s_marca_activada(r,pos_regla);
}

void templ3s_elimregla_agenda(r)
	 templ3s_REGAGENDA r;
{
	int pos_regla;
	int pos_ant,pos_sig;
	char priori;

	pos_regla = templ3s_marca_desactivada(r);
	pos_ant=templ3s_AGENDA[pos_regla].ptro_ant;
	pos_sig=templ3s_AGENDA[pos_regla].ptro_sig;
	priori=templ3s_AGENDA[pos_regla].prioridad+10;
	if (pos_ant!=0) { templ3s_AGENDA[pos_ant].ptro_sig=pos_sig; }
		 else { templ3s_TABLA_PRIO[priori].ptro_ini=pos_sig; }
	if (pos_sig!=0) { templ3s_AGENDA[pos_sig].ptro_ant=pos_ant; }
		 else { templ3s_TABLA_PRIO[priori].ptro_fin=pos_ant; }
	templ3s_AGENDA[pos_regla].ptro_sig=templ3s_pos_libre;
	templ3s_pos_libre=pos_regla;
}

void templ3s_Inicializa_agenda()
{
	int iter1;

templ3s_agenda_vacia = FALSE;
	templ3s_pos_libre=1;
	for(iter1=1; iter1<templ3s_TAM_AGENDA; iter1++)
		 templ3s_AGENDA[iter1].ptro_sig=iter1+1;
	for(iter1=0; iter1<21; iter1++) {
		 templ3s_TABLA_PRIO[iter1].ptro_ini=0;
		 templ3s_TABLA_PRIO[iter1].ptro_fin=0;
	}
}

